<template>
  <v-app class="root">
    <v-main>
      <v-container>
        <div v-if="$accessor.isMobile" :class="{'spacer--isAndroid': $accessor.isAndroid}"
             class="spacer"/>
        <v-card elevation="3">
          <v-card-title>
            Баги ВК
            <v-spacer/>
            <v-menu offset-x offset-y rounded="sm">
              <template #activator="{on}">
                <v-btn v-on="on" icon>
                  <v-icon>mdi-brightness-4</v-icon>
                </v-btn>
              </template>

              <v-list outlined>
                <v-list-item v-for="(value, theme) in themes" :key="theme"
                             :class="{'v-list-item--active': $accessor.theme === theme}" link
                             @click="changeTheme(theme)">
                  {{ value }}
                </v-list-item>
              </v-list>
            </v-menu>
          </v-card-title>
          <v-card-subtitle>
            <a
              :href="`https://gitlab.com/wnm.public/vk-bugs/-/blob/master/CHANGELOG.md#anchor-${version.split('.').join('')}`"
              :style="{color: 'var(--v-primary-base)'}" class="version"
              target="_blank">
              v{{ version }}
            </a>
          </v-card-subtitle>
          <v-card-text>
            Это приложение создано с единственной целью - собирать баги ВК, известные костыли для их
            решения, и
            тестировать, воспроизводится ли баг до сих пор
          </v-card-text>
          <v-card-actions>
            <v-btn color="primary" href="https://gitlab.com/wnm.public/vk-bugs" target="_blank">
              <v-icon>link</v-icon>
              Исходники
            </v-btn>
            <v-btn color="success" href="https://vk.com/daniluk4000" outlined
                   target="_blank">
              <v-icon>person</v-icon>
              Автор
            </v-btn>
          </v-card-actions>
        </v-card>
        <br>
        <nuxt/>
      </v-container>
    </v-main>
  </v-app>
</template>
<script lang="ts">
import Vue from 'vue';
import { Themes } from '~/types';

export default Vue.extend({
  data() {
    return {
      version: require('./../package.json').version,
      themes: {
        light: 'Светлая',
        dark: 'Тёмная',
        default: 'По умолчанию',
      } as Record<Themes, string>,
    };
  },
  async beforeMount() {
    this.$accessor.SET_SERVER(encodeURI(location.protocol + '//' + location.hostname + (location.port
      ? ':' + location.port
      : '') + '/api/'));
  },
  mounted() {
    const vkAppId = this.$wnm.getParam('vk_app_id');
    const vkUserId = this.$wnm.getParam('vk_user_id');

    if (vkAppId && vkUserId)
      this.$accessor.SET_VK_DATA({ appId: parseInt(vkAppId), userId: parseInt(vkUserId) });
  },
  methods: {
    async changeTheme(theme: Themes) {
      if (theme === 'default') {
        await this.$wnm.vkStorage.set('theme', '');
        return location.reload();
      }

      this.$vuetify.theme.dark = theme === 'dark';

      await this.$wnm.vkStorage.set('theme', theme);
      this.$accessor.SET_THEME(theme);
    },
  },
});
</script>

<style lang="scss" scoped>
@media all and (max-width: 700px) {
  .spacer {
    padding-top: 32px;
    padding-top: calc(32px + env(safe-area-inset-top));

    &--isAndroid {
      padding-top: 44px;
    }
  }
}

.version {
  text-decoration: none;
}
</style>
